#include "mali_cv/Error.h"
#include "mali_cv/HOG.h"

using namespace mali_cv;

CLHOG::CLHOG() : hog()
{
}

void CLHOG::internal_create(const HOGInfo &hog_info)
{
	hog.init(hog_info);
}

void CLHOG::internal_init_descriptor(const std::vector<float> &descriptor)
{
	ERROR_ON( hog.info()->descriptor_size() != descriptor.size() );

	auto q = cl::CommandQueue::getDefault();
	hog.map(q, true);
	std::memcpy(hog.descriptor(), descriptor.data(), descriptor.size() * sizeof(float));
	hog.unmap(q);
}
