#include "mali_cv/Distribution.h"

#include "mali_cv/Error.h"

using namespace mali_cv;

CVDistribution::CVDistribution():IDistribution(), h_size(), h_offset(), h_range(), hist()
{
}

void CVDistribution::internal_create(Context &ctx, size_t num_bins, int32_t offset, uint32_t range)
{
	h_size = num_bins;
	h_offset = offset;
	h_range = range;
}

void CVDistribution::read( std::vector<uint32_t> &out)const
{
	if( 1 != hist.cols )
	{
		ERROR("Only 1-dimensional histogram are supported.");
	}
	if ( CV_32F != hist.depth() )
	{
		ERROR("Output type of histogram matrix is not of the expected format.");
	}
	if (hist.isContinuous())
	{
		for( int i = 0; i < hist.rows; ++i )
		{
			uint32_t tmp = static_cast<uint32_t>(*hist.ptr<float>(i));
			out.push_back(tmp);
		}
	}
}
