#include "mali_cv/Error.h"
#include "mali_cv/HOG.h"

using namespace mali_cv;

CVHOG::CVHOG() : hog(), win_stride()
{
}

void CVHOG::internal_create(const HOGInfo &hog_info)
{
	hog.cellSize       = cv::Size(hog_info.cell_size().width, hog_info.cell_size().height);
	hog.blockSize      = cv::Size(hog_info.block_size().width, hog_info.block_size().height);
	hog.blockStride    = cv::Size(hog_info.block_stride().width, hog_info.block_stride().height);
	hog.nbins          = hog_info.num_bins();
	hog.L2HysThreshold = hog_info.l2_hyst_threshold();
}

void CVHOG::internal_init_descriptor(const std::vector<float> &descriptor)
{
}
