#include "mali_cv/Pyramid.h"

#include "mali_cv/Error.h"
#include "mali_cv/Image.h"

using namespace mali_cv;

CVPyramid::CVPyramid() : pyramid()
{
}

void CVPyramid::internal_create( Context &ctx, size_t levels, float scale, size_t w, size_t h, Format fmt )
{
	pyramid.clear();
	pyramid.resize(levels);

	for( size_t i = 0; i < levels; i++)
	{
		ERROR_ON( w < 16 || h < 16);
		pyramid[i] = CVImageAlloc();
		pyramid[i]->create(ctx, w, h, fmt);
		w = (w + 1) * scale;
		h = (h + 1) * scale;
	}
}

void CVPyramid::store( std::vector<ImagePtr> &out )
{
	ERROR_ON( out.size() != pyramid.size() );
	for(uint i = 0; i < pyramid.size(); i++)
	{
		out[i]->cv.img = pyramid[i]->img;
		ERROR_ON(out[i]->cv.width  != pyramid[i]->width);
		ERROR_ON(out[i]->cv.height != pyramid[i]->height);
	}
}
