#include <mali_cv/RemapTable.h>
#include <mali_cv/Image.h>

using namespace mali_cv;

CVRemapTable::CVRemapTable():table()
{
}

void CVRemapTable::internal_create(Context &ctx, size_t src_width, size_t src_height, size_t dst_width, size_t dst_height)
{
	table.clear();
	table.resize(2);

	/* Allocate memory for mapx */
	table[0] = CVImageAlloc();
	table[0]->create(ctx, dst_width, dst_height, Format::FP32C1);

	/* Allocate memory for mapy */
	table[1] = CVImageAlloc();
	table[1]->create(ctx, dst_width, dst_height, Format::FP32C1);
}

void CVRemapTable::set_remap_point(int dst_x, int dst_y, float src_x, float src_y)
{
	/* Set X coordinate */
	table[0]->img.at<float>(dst_y, dst_x) = src_x;

	/* Set Y coordinate */
	table[1]->img.at<float>(dst_y, dst_x) = src_y;
}
