#include "mali_cv/Context.h"

#include "mali_cv/Error.h"

using namespace mali_cv;

Context::Context(uint num_iterations, BorderMode border_mode, uint8_t constant_border_value):
	vx(),_num_iterations(num_iterations),
	_border_mode(border_mode),
	_constant_border_value(constant_border_value) {}

uint Context::num_iterations() const
{
	return _num_iterations;
}

BorderMode Context::border_mode() const
{
	return _border_mode;
}

uint8_t Context::constant_border_value() const
{
	return _constant_border_value;
}
