#include "mali_cv/Error.h"

#include <cstdarg>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <map>
#include <stdexcept>

using namespace mali_cv;

void mali_cv::error( const char *function, const char *file, const int line, const char *msg, ...)
{
	char out[512];
	va_list args;
	va_start(args, msg);
	int offset = snprintf(out, sizeof(out), "ERROR in %s %s:%d: ", function, file, line);
	vsnprintf(out + offset, sizeof(out) - offset, msg, args);
	va_end(args);

	throw std::runtime_error(out);
}
