#include "mali_cv/Error.h"
#include "mali_cv/HOG.h"

using namespace mali_cv;

void IHOG::create(const HOGInfo &hog_info)
{
	internal_create(hog_info);
}

void IHOG::init_descriptor(const std::vector<float> &descriptor)
{
	internal_init_descriptor(descriptor);
}

HOG::HOG(const HOGInfo &hog_info) : cv(),vx(),cl(),ne(),descriptor_size(hog_info.descriptor_size())
{
	cv.create(hog_info);
	vx.create(hog_info);
	cl.create(hog_info);
	ne.create(hog_info);
}

void HOG::init_descriptor(const std::vector<float> &descriptor)
{
	ERROR_ON(descriptor.size() != descriptor_size);
	cv.init_descriptor(descriptor);
	vx.init_descriptor(descriptor);
	cl.init_descriptor(descriptor);
	ne.init_descriptor(descriptor);
}
