#include "mali_cv/Distribution.h"

#include "support/ToolchainSupport.h"
#include "mali_cv/Error.h"

using namespace mali_cv;

NEDistribution::NEDistribution():IDistribution(), dist(nullptr)
{
}

void NEDistribution::internal_create(Context &ctx, size_t bins, int32_t offset, uint32_t range)
{
	dist = arm_compute::support::cpp14::make_unique<arm_compute::Distribution1D>(bins, offset, range);
}

void NEDistribution::read( std::vector<uint32_t> &out)const
{
	const uint32_t *ptr = dist->buffer();

	for(unsigned int i = 0; i < dist->num_bins(); ++i)
	{
		out.push_back(ptr[i]);
	}
}
