#include "mali_cv/Pyramid.h"

#include "mali_cv/Error.h"
#include "mali_cv/Helper.h"
#include "mali_cv/Image.h"

using namespace mali_cv;

NEPyramid::NEPyramid() : pyramid()
{
}

void NEPyramid::internal_create( Context &ctx, size_t levels, float scale, size_t w, size_t h, Format fmt)
{
	arm_compute::PyramidInfo pyramid_info;
	pyramid_info.init(levels, scale, w, h, ARM_COMPUTEHelper::convert_to_arm_compute_format(fmt));
	pyramid.init_auto_padding(pyramid_info);
	pyramid.allocate();
}

void NEPyramid::store( std::vector<ImagePtr> &out )
{
	ERROR_ON(out.size() != pyramid.info()->num_levels() );

	for(uint i = 0; i < pyramid.info()->num_levels(); i++)
	{
		ERROR_ON( out[i]->ne.image.info()->dimension(0)  != pyramid.get_pyramid_level(i)->info()->dimension(0) );
		ERROR_ON( out[i]->ne.image.info()->dimension(1) != pyramid.get_pyramid_level(i)->info()->dimension(1) );
		out[i]->ne.image.copy_from(*pyramid.get_pyramid_level(i));
	}
}
