#include "mali_cv/Target.h"

#include "mali_cv/Error.h"
#include "mali_cv/Distribution.h"

using namespace mali_cv;

ITarget::ITarget(Context &context): _ctx(context), _timer()
{
}

void ITarget::absolute_difference( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::bitwise_or( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::bitwise_and( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::bitwise_xor( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::bitwise_not( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::accumulate( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::accumulate_squared( Image &, Image &, uint32_t)
{
	ERROR("Not implemented");
}
void ITarget::accumulate_weighted( Image &, Image &, float)
{
	ERROR("Not implemented");
}
void ITarget::accumulate_weighted_fp16( Image &, Image &, float)
{
	ERROR("Not implemented");
}
void ITarget::arithmetic_addition( Image &, Image &, Image &, uint8_t)
{
	ERROR("Not implemented");
}
void ITarget::arithmetic_subtraction( Image &, Image &, Image &, uint8_t)
{
	ERROR("Not implemented");
}
void ITarget::harris_corners(Image &,float,float,float,uint8_t,uint8_t, IKeyPointArray&,size_t&)
{
	ERROR("Not implemented");
}
void ITarget::harris_corners_fp16(Image &,float,float,float,uint8_t,uint8_t, IKeyPointArray&,size_t&)
{
	ERROR("Not implemented");
}
void ITarget::fast_corners(Image &,float, bool , IKeyPointArray &,size_t &)
{
	ERROR("Not implemented");
}
void ITarget::erode( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::dilate( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::gaussian3x3( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::gaussian5x5( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::box3x3( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::box3x3_fp16( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::median3x3( Image &a, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::convolution( Image &a, Image &c, Convolution &convolution_matrix)
{
	ERROR("Not implemented");
}
void ITarget::scale( Image &a, Image &c, InterpolationMode mode)
{
	ERROR("Not implemented");
}
void ITarget::color_convert( Image &a, Image &c )
{
	ERROR("Not implemented");
}
void ITarget::sobel( Image &a, Image *c, Image *d )
{
	ERROR("Not implemented");
}
void ITarget::sobel5x5( Image &a, Image *c, Image *d )
{
	ERROR("Not implemented");
}
void ITarget::scharr( Image &a, Image *c, Image *d )
{
	ERROR("Not implemented");
}
void ITarget::derivative( Image &a, Image *c, Image *d )
{
	ERROR("Not implemented");
}
void ITarget::sobel7x7( Image &a, Image *c, Image *d )
{
	ERROR("Not implemented");
}
void ITarget::gaussian_pyramid( Image &a, Pyramid &pyramid)
{
	ERROR("Not implemented");
}
void ITarget::laplacian_pyramid( Image &a, Pyramid &pyramid, Image &b, bool timers_enabled)
{
	ERROR("Not implemented");
}
void ITarget::laplacian_reconstruct( Pyramid &, Image &, Image &)
{
	ERROR("Not implemented");
}
void ITarget::canny(Image &a, int32_t upper, int32_t lower, int32_t gradient_size, int32_t norm_type, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::canny_fp16(Image &a, int32_t upper, int32_t lower, int32_t gradient_size, int32_t norm_type, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::mean_stddev(Image &a, Scalar<float> &mean, Scalar<float> &stddev)
{
	ERROR("Not implemented");
}
void ITarget::warp_affine(Image &a, Image &c, const float matrix[3][2], InterpolationMode mode)
{
	ERROR("Not implemented");
}
void ITarget::warp_perspective(Image &a, Image &c, const float matrix[3][3], InterpolationMode mode)
{
	ERROR("Not implemented");
}
void ITarget::magnitude( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::magnitude_fp16( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::phase( Image &a, Image &b, Image &c)
{
	ERROR("Not implemented");
}
void ITarget::threshold_binary( Image &a, Image &b, uint8_t threshold, uint8_t false_value, uint8_t true_value)
{
	ERROR("Not implemented");
}
void ITarget::threshold_range( Image &a, Image &b, uint8_t threshold, uint8_t false_value, uint8_t true_value, uint8_t upper)
{
	ERROR("Not implemented");
}
void ITarget::remap( Image &a, RemapTable &table, Image &d, InterpolationMode policy)
{
	ERROR("Not implemented");
}
void ITarget::pixelwise_mul( Image &a , Image &b, Image &c, float scale, uint8_t overflow_policy, uint8_t round_policy )
{
	ERROR("Not implemented");
}
void ITarget::channel_extract( Image &a, Channel channel, Image &c )
{
	ERROR("Not implemented");
}
void ITarget::tablelookup( Image &a , Lut &b, Image &c )
{
	ERROR("Not implemented");
}
void ITarget::convert_depth( Image &a, Image &c, ConvertPolicy policy , uint32_t shift)
{
	ERROR("Not implemented");
}
void ITarget::minmaxlocation( Image &a, Scalar<int32_t> &min, Scalar<int32_t> &max, ICoord2DArray *min_loc, ICoord2DArray *max_loc,
                              Scalar<uint32_t> *min_count, Scalar<uint32_t> *max_count )
{
	ERROR("Not implemented");
}
void ITarget::histogram(Image &a, Distribution &b)
{
	ERROR("Not implemented");
}
void ITarget::equalize_histogram(Image &a, Image &b)
{
	ERROR("Not implemented");
}
void ITarget::channel_combine(Image &plane0, Image &plane1, Image &plane2, Image &plane3, Image &out)
{
	ERROR("Not implemented");
}
void ITarget::optical_flow(Image &a, Image &b, IKeyPointArray *old_points, IKeyPointArray *new_points_estimates,
                           IKeyPointArray *new_points, Termination termination, float epsilon, uint32_t num_iterations,
                           bool use_initial_estimate, size_t window_dimension, size_t num_levels)
{
	ERROR("Not implemented");
}
void ITarget::integral(Image &a, Image &b)
{
	ERROR("Not implemented");
}
void ITarget::non_linear_filter(Image &a, Image &b, NonLinearFilterFunction function, MatrixPattern pattern, uint mask_size, uint8_t* mask)
{
	ERROR("Not implemented");
}
void ITarget::activation_layer(Tensor &in, Tensor &out, ActivationLayerInfo act_info)
{
	ERROR("Not implemented");
}
void ITarget::normalization_layer(Tensor &a, Tensor &b, NormalizationLayerInfo norm_info)
{
	ERROR("Not implemented");
}
void ITarget::batchnormalization_layer(Tensor &a, Tensor &b, Tensor &mean, Tensor &var, Tensor &beta, Tensor &gamma, float epsilon)
{
	ERROR("Not implemented");
}
void ITarget::pooling_layer(Tensor &in, Tensor &out, PoolingLayerInfo pool_info)
{
	ERROR("Not implemented");
}
void ITarget::softmax_layer(Tensor &in, Tensor &out)
{
	ERROR("Not implemented");
}
void ITarget::tensor_ops(Tensor &in1, Tensor &in2, Tensor &out, TensorOp op)
{
	ERROR("Not implemented");
}
void ITarget::convolution_layer(Tensor &in, Tensor &w, Tensor *b, Tensor &out, PadStrideInfo conv_info, Tensor *rw)
{
	ERROR("Not implemented");
}
void ITarget::hog_descriptor(Image &a, HOG &b, Tensor &c)
{
	ERROR("Not implemented");
}
void ITarget::hog_detector(Tensor &a, HOG &b, IKeyPointArray &keypoint_detection_windows)
{
	ERROR("Not implemented");
}
void ITarget::hog_multi_detection(Image &a, HOG &b, IKeyPointArray &keypoint_detection_windows)
{
	ERROR("Not implemented");
}
void ITarget::fully_connected_layer(Tensor &input, Tensor &weight, Tensor *bia, Tensor &output, bool are_weights_reshaped)
{
	ERROR("Not implemented");
}
void ITarget::transpose(Image &a, Image &b)
{
	ERROR("Not implemented");
}
void ITarget::gemm_fp32(Tensor &a, Tensor &b, Tensor &c, Tensor &d, float alpha, float beta)
{
	ERROR("Not implemented");
}
void ITarget::gemm_fp16(Image &a, Image &b, Image &c, Image &d, float alpha, float beta)
{
	ERROR("Not implemented");
}
void ITarget::gemm_lowp(Image &a, Image &b, Image &d, int32_t a_offset, int32_t b_offset, int32_t c_offset, int32_t c_mult_int, int32_t shift)
{
	ERROR("Not implemented");
}
void ITarget::interleave_4x4(Image &in, Image &out)
{
	ERROR("Not implemented");
}
void ITarget::concatenate_depth( std::vector<std::unique_ptr<Tensor>> &a, Tensor &b)
{
	ERROR("Not implemented");
}
void ITarget::transpose_1xW(Image &in, Image &out)
{
	ERROR("Not implemented");
}

void ITarget::locally_connected_layer(Tensor &in, Tensor &w, Tensor *b, Tensor &out, PadStrideInfo conv_info)
{
	ERROR("Not implemented");
}
