#include <mali_cv/Array.h>
#include <iostream>

namespace mali_cv
{

template<class T>
void VXArray<T>::read_internal( std::vector<T> &out, void* base, const vx_size num_items, const vx_size stride ) const
{
}

template<>
void VXArray<IKeyPoint>::read_internal( std::vector<IKeyPoint> &out, void* base, const vx_size num_items, const vx_size stride ) const
{
	for( vx_size i = 0; i < num_items; ++i )
	{
		IKeyPoint kp;
		kp.x = vxArrayItem( vx_keypoint_t, base, i, stride).x;
		kp.y = vxArrayItem( vx_keypoint_t, base, i, stride).y;
		kp.strength = vxArrayItem( vx_keypoint_t, base, i, stride).strength;
		kp.scale = vxArrayItem( vx_keypoint_t, base, i, stride).scale;
		kp.orientation = vxArrayItem( vx_keypoint_t, base, i, stride).orientation;
		kp.tracking_status = vxArrayItem( vx_keypoint_t, base, i, stride).tracking_status;
		kp.error = vxArrayItem( vx_keypoint_t, base, i, stride).error;
		out.push_back(kp);
	}
}

template<>
void VXArray<ICoordinates2D>::read_internal( std::vector<ICoordinates2D> &out, void* base, const vx_size num_items, const vx_size stride ) const
{
	for( vx_size i = 0; i < num_items; ++i )
	{
		ICoordinates2D coord;
		coord.x = vxArrayItem( vx_keypoint_t, base, i, stride).x;
		coord.y = vxArrayItem( vx_keypoint_t, base, i, stride).y;
		out.push_back(coord);
	}
}

template<class T>
void VXArray<T>::fill_internal( std::vector<T> &in)
{
}

template<>
void VXArray<IKeyPoint>::fill_internal( std::vector<IKeyPoint> &in)
{
	for( vx_size i = 0; i < in.size(); ++i )
	{

		IKeyPoint kp = in.at(i);
		vx_keypoint_t keypoint;
		keypoint.x = kp.x;
		keypoint.y = kp.y;
		keypoint.strength = kp.strength;
		keypoint.scale = kp.scale;
		keypoint.orientation = kp.orientation;
		keypoint.tracking_status = kp.tracking_status;
		keypoint.error = kp.error;
		vxAddArrayItems(this->a, 1, &keypoint, sizeof(vx_keypoint_t));
	}
}

template<>
void VXArray<ICoordinates2D>::fill_internal( std::vector<ICoordinates2D> &in)
{
}

}