#include "mali_cv/RemapTable.h"

#include "mali_cv/Error.h"
#include "mali_cv/Context.h"

using namespace mali_cv;

VXRemapTable::VXRemapTable():table(nullptr)
{
}

void VXRemapTable::internal_create(Context &ctx, size_t src_width, size_t src_height, size_t dst_width, size_t dst_height)
{
	table = vxCreateRemap(ctx.vx.context(), src_width, src_height, dst_width, dst_height);

	ERROR_ON(!table);
}

void VXRemapTable::set_remap_point(int dst_x, int dst_y, float src_x, float src_y)
{
	CHECK_VX( vxSetRemapPoint(table, dst_x, dst_y, src_x, src_y) );
}

VXRemapTable::~VXRemapTable()
{
	CHECK_VX( vxReleaseRemap( &table ) );
}
