#ifndef __CV_FILE_H__
#define __CV_FILE_H__

#include <memory>
#include <string>

namespace mali_cv
{
class File
{
	public:
		File(const std::string &filename, const std::string &mode);
		void open(const std::string &filename, const std::string &mode);
		void close();
		size_t size() const;
		void read( void *data, size_t size );
		void write( const void *ptr, size_t size);
		void printf( const char *msg, ...);
		void scanf( const char *format, ...);
		char getc();
		void ungetc( char c );
		FILE *fd();
	private:
		std::unique_ptr<FILE, decltype(&fclose)> _fd;
		mutable size_t _size;
		std::string _filename;
};
}
#endif /* __CV_FILE_H__ */
