#ifndef __CV_RAW_IMAGEBASE_H__
#define __CV_RAW_IMAGEBASE_H__

#include "mali_cv/Types.h"

#include <cstddef>

namespace mali_cv
{
class RawImageBase
{
	public:
		RawImageBase();
		RawImageBase( size_t width, size_t height, Format format );
		virtual ~RawImageBase() = default;
		void create( size_t width, size_t height, Format format );

		size_t width()const;
		size_t height()const;
		Format format()const;
		size_t pixel_size()const;
		size_t num_pixels()const;
		uint   num_channels()const;
		uint   element_size()const;

		static size_t get_pixel_size( Format format );
		static const char *format_str( Format format );
		static uint get_num_channels( Format format );
		static uint get_element_size( Format format );
	private:
		Format _format;
		size_t _width, _height;
		size_t _pixel_size;
};
}
#endif /* __CV_RAW_IMAGEBASE_H__ */
