namespace mali_cv
{
class CannyEdge:public ITest
{
	public:
		const std::string name() const override
		{
			return "CannyEdge";
		}
		CannyEdge( Environment &env, RawImage &in, int32_t threshold_upper, int32_t threshold_lower, int32_t gradient, int32_t norm)
		:ITest(env),a(env.ctx,in,CopyData::YES),c(env.ctx,in.width(),in.height(), in.format()),upper(threshold_upper),lower(threshold_lower),
		gradient_size(gradient),norm_type(norm)
		{
		}

		void run(ITarget *target)override
		{
			target->canny(a, upper,lower,gradient_size, norm_type, c);
		}
		void validate_outputs() override
		{
			/* exclude the border as in the suppression, we don't calculate the border */
			Validate::single_image_output( c, env, env.border_to_exclude_if_undefined( 1 + (gradient_size / 2), 1) );
		}
	protected:
		Image a,c;
		int32_t upper, lower;
		int32_t gradient_size, norm_type;
};


class CannyEdge_FP16:public CannyEdge
{
	public:
		const std::string name() const override
		{
			return "CannyEdge_FP16";
		}
		CannyEdge_FP16( Environment &env, RawImage &in, int32_t threshold_upper, int32_t threshold_lower, int32_t gradient, int32_t norm) :
			CannyEdge(env,in,threshold_upper,threshold_lower,gradient,norm) {}

		void run(ITarget *target)override
		{
			target->canny_fp16(a, upper,lower,gradient_size, norm_type, c);
		}
};

} /* mali_cv */
