#include <sstream>
#include <string>

namespace mali_cv
{
class ColorConvert: public ITest
{
	public:
		ColorConvert(Environment &env, RawImage &in, Format out_format) : ITest(env),
		    _in(env.ctx, in, CopyData::YES),
		    _out(env.ctx, in.width(), in.height(), out_format),
			_name()
		{
			std::stringstream tmp_name;
			tmp_name << "ColorConvert_" << RawImageBase::format_str(in.format()) << "_to_" << RawImageBase::format_str(out_format);
			_name = tmp_name.str();
		}
		void run(ITarget *target) override
		{
			target->color_convert(_in, _out);
		}
		void validate_outputs() override
		{
			Validate::single_image_output(_out, env);
		}
		const std::string name() const override
		{
			return _name.c_str();
		}
	protected:
		Image _in, _out;
		std::string _name;
};
} /* mali_cv */
