#ifndef __TEST_DERIVATIVE_H__
#define __TEST_DERIVATIVE_H__

namespace mali_cv
{
	class Derivative: public ITest
	{
		public:
			const std::string name() const override
			{
				return "Derivative";
			}
			Derivative( Environment &env, RawImage &in):ITest(env), a(env.ctx, in, CopyData::YES), c(env.ctx, in.width(), in.height(), Format::LUMINANCE16), d(env.ctx, in.width(), in.height(), Format::LUMINANCE16)
			{
			}
			virtual void run(ITarget *target)override
			{
				target->derivative(a, &c, &d);
			}
			virtual void validate_outputs() override
			{
				Validate::double_image_output( c, d, env, env.border_to_exclude_if_undefined( 1 ) );
			}
		protected:
			Image a, c, d;
	};

	class DerivativeX: public ITest
	{
		public:
			const std::string name() const override
			{
				return "DerivativeX";
			}
			DerivativeX( Environment &env, RawImage &in):ITest(env), a(env.ctx, in, CopyData::YES), c(env.ctx, in.width(), in.height(), Format::LUMINANCE16)
			{
			}
			virtual void run(ITarget *target)override
			{
				target->derivative(a, &c, NULL);
			}
			virtual void validate_outputs() override
			{
				Validate::single_image_output( c, env, env.border_to_exclude_if_undefined( 1 ) );
			}
		protected:
			Image a, c;
	};

	class DerivativeY: public ITest
	{
		public:
			const std::string name() const override
			{
				return "DerivativeY";
			}
			DerivativeY( Environment &env, RawImage &in):ITest(env), a(env.ctx, in, CopyData::YES), c(env.ctx, in.width(), in.height(), Format::LUMINANCE16)
			{
			}
			virtual void run(ITarget *target)override
			{
				target->derivative(a, NULL, &c);
			}
			virtual void validate_outputs() override
			{
				Validate::single_image_output( c, env, env.border_to_exclude_if_undefined( 1 ) );
			}
		protected:
			Image a, c;
	};
} /* mali_cv */

#endif /* __TEST_DERIVATIVE_H__ */
