#include "mali_cv/Types.h"
#include "mali_cv/Context.h"

#include <cstring>

namespace mali_cv
{
	class IntegralImage: public ITest
	{
		public:
			const std::string name() const override
			{
				return "IntegralImage";
			}

			IntegralImage( Environment &env, RawImage &_a)
			: ITest(env), a(env.ctx, _a, CopyData::YES), b(env.ctx, _a.width(), _a.height(), Format::U32) {}

			virtual void run(ITarget *target)override
			{
				target->integral(a,b);
			}

			virtual void validate_outputs() override
			{
				Validate::single_image_output( b, env, 0 );
			}

		protected:
			Image a, b;
	};
}
