#include "mali_cv/Context.h"
#include "mali_cv/Types.h"

namespace mali_cv
{
	class Magnitude: public ITest
	{
		public:
			const std::string name() const override
			{
				return "Magnitude";
			}

			Magnitude( Environment &env, RawImage &_a, RawImage &_b) : ITest(env),
				a(env.ctx, _a, CopyData::YES), b(env.ctx, _b, CopyData::YES), c(env.ctx, _a.width(), _a.height(), Format::LUMINANCE16) {}

			virtual void run(ITarget *target)override
			{
				target->magnitude(a,b,c);
			}
			virtual void validate_outputs() override
			{
				Validate::single_image_output( c, env, 0 );
			}
		protected:
			Image a,b,c;
	};

	class Magnitude_FP16: public Magnitude
	{
		public:
			const std::string name() const override
			{
				return "Magnitude_FP16";
			}

			Magnitude_FP16( Environment &env, RawImage &_a, RawImage &_b) : Magnitude(env,_a,_b) {}

			void run(ITarget *target)override
			{
				target->magnitude_fp16(a,b,c);
			}
	};

}
