#include "mali_cv/Context.h"
#include "mali_cv/Types.h"

namespace mali_cv
{

class Phase: public ITest
{
	public:
		const std::string name() const override { return "Phase";}

		Phase( Environment &env, RawImage &_a, RawImage &_b) : ITest(env),
			a(env.ctx, _a, CopyData::YES), b(env.ctx, _b, CopyData::YES), c(env.ctx, _a.width(), _a.height(), Format::LUMINANCE) {}

		virtual void run(ITarget *target)override
		{
			target->phase(a,b,c);
		}
		virtual void validate_outputs() override
		{
			Validate::single_image_output( c, env, 0 );
		}
	protected:
		Image a,b,c;
};
}
