namespace mali_cv
{

class Scale: public ITest
{
	public:
		const std::string name() const override
		{
			return "ScaleImage";
		}
		Scale( Environment &env, RawImage &in, int out_width, int out_height, InterpolationMode mode):ITest(env), a(env.ctx, in, CopyData::YES), c(env.ctx, out_width, out_height, in.format()), interpolation(mode)
		{
		}
		void run(ITarget *target)override
		{
			target->scale(a, c, interpolation);
		}
		void validate_outputs() override
		{
			Validate::single_image_output( c, env );
		}
	protected:
		Image a, c;
		InterpolationMode interpolation;
};


class ScaleUpNearest: public Scale
{
	public:
		const std::string name() const override
		{
			return "ScaleUpNearest";
		}
		ScaleUpNearest( Environment &env, RawImage &in, float factor) : Scale(env, in , in.width() * factor, in.height()*factor, InterpolationMode::NEAREST_NEIGHBOR)
        {
        }
		void run(ITarget *target)override
		{
			target->scale(a, c, interpolation);
		}
		void validate_outputs() override
		{
			Validate::single_image_output( c, env );
		}
};


} /* mali_cv */
