#include "mali_cv/Context.h"
#include "mali_cv/Types.h"

namespace mali_cv
{
class SoftmaxLayer : public ITest
{
	public:
		const std::string name() const override
		{
			return "SoftmaxLayer";
		}
		SoftmaxLayer( Environment &env, TensorShape shape, DataType dt)
		: ITest(env), _a(env.ctx, shape, dt), _c(env.ctx, shape, dt)
		{
			_a.random_fill(-10, 10);
		}

		virtual void run(ITarget *target) override
		{
			target->softmax_layer(_a, _c);
		}
		virtual void validate_outputs() override
		{
			Validate::single_tensor_output( _c, env, 0 );
		}
	protected:
		Tensor _a, _c;
};
}