#ifndef __EXTRA_NODES_H__
#define __EXTRA_NODES_H__

#include <VX/vx.h>
#include <VX/vx_helper.h>
#include <math.h>
/* TODO: remove vx_compatibility.h after transition period */
#include <VX/vx_compatibility.h>

#ifdef __cplusplus
extern "C" {
#endif

vx_status vxCannyEdge(vx_image input, vx_threshold hyst, vx_scalar gradient_size, vx_scalar norm_type, vx_image output, vx_border_t *bordermode);

vx_status vxGaussianPyramid(vx_image input, vx_pyramid gaussian, vx_border_t *bordermode);

vx_status vxLaplacianPyramid(vx_image input, vx_pyramid laplacian, vx_image output, vx_border_t *bordermode);

vx_status vxLaplacianReconstruct(vx_pyramid laplacian, vx_image input, vx_image output, vx_border_t *bordermode);

vx_status vxHarrisCorners(vx_image input, vx_scalar strength_thresh, vx_scalar min_distance, vx_scalar sensitivity, vx_scalar gradient_size, vx_scalar block_size, vx_array corners,
                          vx_scalar num_corners, vx_border_t *bordermode);

vx_status vxOpticalFlowPyrLK_full(vx_pyramid old_pyramid, vx_pyramid new_pyramid, vx_array prevPts, vx_array estimatedPts, vx_array nextPts, vx_scalar termination, vx_scalar epsilon,
                                  vx_scalar num_iterations, vx_scalar use_initial_estimate, vx_scalar window_dimension, vx_border_t *bordermode);
#ifdef __cplusplus
}
#endif

#endif /*__EXTRA_NODES_H__*/
